int
dwg_decode_entity_handles (Bit_Chain * dat, Dwg_Object * obj)
{
  int i;
  char tmp[1024];
  long unsigned vcount;
  Dwg_Object_Entity *_ent;
  Dwg_Struct *dwg = obj->parent;
  _ent = &obj->as.entity;
  if (_ent->entity_mode == 0)
    {
      if (bit_read_H (dat, &_ent->subentity))
	return (0);
      snprintf (tmp, 1024, "  " "subentity" ": HANDLE(%d.%d.%lu)\n", _ent->subentity.code, _ent->subentity.size,
		_ent->subentity.value);
      LOG_TRACE (tmp);;
    }
  if (obj->num_reactors > 0)
    obj->reactors = (BITCODE_H *) malloc (sizeof (BITCODE_H) * obj->num_reactors);
  for (vcount = 0; vcount < obj->num_reactors; vcount++)
    {
      if (bit_read_H (dat, &obj->reactors[vcount]))
	return (0);
      snprintf (tmp, 1024, "  reactors[%lu]: HANDLE(%X.%d.%lu)\n", vcount, obj->reactors[vcount].code,
		obj->reactors[vcount].size, obj->reactors[vcount].value);
      LOG_TRACE (tmp);
    }
  if (dwg->header.version >= R_2004)
    {
      if (!obj->xdic_missing_flag)
	{
	  if (bit_read_H (dat, &obj->xdicobjhandle))
	    return (0);
	  snprintf (tmp, 1024, "  xdicobjhandle: HANDLE(%X.%d.%lu)\n", obj->xdicobjhandle.code, obj->xdicobjhandle.size,
		    obj->xdicobjhandle.value);
	  LOG_TRACE (tmp);
	}
    }
  else
    {
      if (bit_read_H (dat, &obj->xdicobjhandle))
	return (0);
      snprintf (tmp, 1024, "  xdicobjhandle: HANDLE(%X.%d.%lu)\n", obj->xdicobjhandle.code, obj->xdicobjhandle.size,
		obj->xdicobjhandle.value);
      LOG_TRACE (tmp);
    }
  if (dwg->header.version >= R_13 && dwg->header.version <= R_14)
    {
      if (bit_read_H (dat, &_ent->layer))
	return (0);
      snprintf (tmp, 1024, "  " "layer" ": HANDLE(%d.%d.%lu)\n", _ent->layer.code, _ent->layer.size, _ent->layer.value);
      LOG_TRACE (tmp);;
      if (!_ent->isbylayerlt)
	{
	  if (bit_read_H (dat, &_ent->ltype))
	    return (0);
	  snprintf (tmp, 1024, "  " "ltype" ": HANDLE(%d.%d.%lu)\n", _ent->ltype.code, _ent->ltype.size,
		    _ent->ltype.value);
	  LOG_TRACE (tmp);;
	}
    }
  if (dwg->header.version <= R_2000)
    {
      if (!_ent->nolinks)
	{
	  if (bit_read_H (dat, &_ent->prev_entity))
	    return (0);
	  snprintf (tmp, 1024, "  " "prev_entity" ": HANDLE(%d.%d.%lu)\n", _ent->prev_entity.code,
		    _ent->prev_entity.size, _ent->prev_entity.value);
	  LOG_TRACE (tmp);;
	  if (bit_read_H (dat, &_ent->next_entity))
	    return (0);
	  snprintf (tmp, 1024, "  " "next_entity" ": HANDLE(%d.%d.%lu)\n", _ent->next_entity.code,
		    _ent->next_entity.size, _ent->next_entity.value);
	  LOG_TRACE (tmp);;
	}
    }
  if (dwg->header.version >= R_2000)
    {
      if (bit_read_H (dat, &_ent->layer))
	return (0);
      snprintf (tmp, 1024, "  " "layer" ": HANDLE(%d.%d.%lu)\n", _ent->layer.code, _ent->layer.size, _ent->layer.value);
      LOG_TRACE (tmp);;
      if (_ent->linetype_flags == 3)
	{
	  if (bit_read_H (dat, &_ent->ltype))
	    return (0);
	  snprintf (tmp, 1024, "  " "ltype" ": HANDLE(%d.%d.%lu)\n", _ent->ltype.code, _ent->ltype.size,
		    _ent->ltype.value);
	  LOG_TRACE (tmp);;
	}
    }
  if (dwg->header.version >= R_2007)
    {
      if (_ent->material_flags == 3)
	{
	  if (bit_read_H (dat, &_ent->material))
	    return (0);
	  snprintf (tmp, 1024, "  " "material" ": HANDLE(%d.%d.%lu)\n", _ent->material.code, _ent->material.size,
		    _ent->material.value);
	  LOG_TRACE (tmp);;
	}
    }
  if (dwg->header.version >= R_2000)
    {
      if (_ent->plotstyle_flags == 3)
	{
	  if (bit_read_H (dat, &_ent->plotstyle))
	    return (0);
	  snprintf (tmp, 1024, "  " "plotstyle" ": HANDLE(%d.%d.%lu)\n", _ent->plotstyle.code, _ent->plotstyle.size,
		    _ent->plotstyle.value);
	  LOG_TRACE (tmp);;
	}
    }
  return (1);
}
